<?php

if (!defined("WHMCS")) {
    die("This file cannot be accessed directly");
}

use WHMCS\Domains\DomainLookup\ResultsList;
use WHMCS\Domains\DomainLookup\SearchResult;
use WHMCS\Module\Registrar\Registrarmodule\ApiClient;

if(!defined('DS'))
    define('DS',DIRECTORY_SEPARATOR);

if(!class_exists('infrastructurerepublic'))
    require_once dirname(__FILE__).DS.'class.infrastructurerepublic.php';


/*
 * helper functions
 */
if(function_exists('mysql_safequery') == false) {
    function mysql_safequery($query,$params = false) {
        if ($params) {
            foreach ($params as &$v) { $v = mysql_real_escape_string($v); }
            $sql_query = vsprintf( str_replace("?","'%s'",$query), $params );
            $sql_query = mysql_query($sql_query);
        } else {
            $sql_query = mysql_query($query);
        }
        return ($sql_query);
    }
}


/**
 * Define module related metadata
 *
 * Provide some module information including the display name and API Version to
 * determine the method of decoding the input values.
 *
 * @return array
 */
function infrastructurerepublic_MetaData()
{
    return array(
        'DisplayName' => 'Infrastructurerepublic WHMCS',
        'APIVersion' => '1.8',
    );
}

function infrastructurerepublic_isModuleDomain($domainid){
    
    $res = mysql_fetch_assoc(mysql_safequery("SELECT registrar FROM tbldomains WHERE id=?",array($domainid)));
    return $res['registrar'] == 'infrastructurerepublic';
    
}

function infrastructurerepublic_getModuleFields($params){
    
    mysql_safequery("
        CREATE TABLE IF NOT EXISTS `infrastructurerepublic` (
        `domainid` int(11) NOT NULL,
        `name` varchar(255) NOT NULL,
        `value` text NOT NULL DEFAULT ''
       ) ENGINE=InnoDB DEFAULT CHARSET=latin1
    ");

    $values = array();
    $res = mysql_safequery("SELECT * FROM infrastructurerepublic WHERE domainid=?",array($params['domainid']));
    while($row = mysql_fetch_assoc($res)){
        $values[$row['name']] = $row['value'];
    }
    $fields = array(
        'domainid' => array(
            'value' => $values['domainid'],
        //    'label' => 'Domain ID',
        //    'html' => '<input type="text" name="modulefields[domainid]" value="'.$values['domainid'].'"  id="infrastructurerepublic__domainid" disabled/>	<input type="checkbox" onchange=\'$(this).is(":checked")?$("#infrastructurerepublic__domainid").attr("disabled", false):$("#infrastructurerepublic__domainid").attr("disabled", true)\'>Edit',
        ),
        'orderid' => array(
            'value' => $values['orderid'],
        //    'label' => 'Order ID',
        //    'html' => '<input type="text" name="modulefields[orderid]" value="'.$values['orderid'].'"  id="infrastructurerepublic__orderid" disabled/>	<input type="checkbox" onchange=\'$(this).is(":checked")?$("#infrastructurerepublic__orderid").attr("disabled", false):$("#infrastructurerepublic__orderid").attr("disabled", true)\'>Edit',
        ),
        'invoiceid' => array(
            'value' => $values['invoiceid'],
        ),
        'domainstatus' => array(
            'value' => $values['domainstatus'],
            'label' => 'Domain Status',
            'html' => "<b>".$values['domainstatus']."</b>",
        ),
        'authcode' => array(
            'value' => $values['authcode'],
            'label' => 'Domain Transfer Secret',
            'html' => "".$values['authcode']."",
        ),
    );
    
    return $fields;
}

function infrastructurerepublic_saveModuleFields($params,$data){

    $fields = infrastructurerepublic_getModuleFields($params);
    
    foreach($fields as $k => $field){
        if(isset($data[$k])){
            if($field['value']===null){
                mysql_safequery("INSERT INTO infrastructurerepublic (domainid,name,value) VALUES (?,?,?)",array($params['domainid'],$k,$data[$k]));
            }
            else{
                mysql_safequery("UPDATE infrastructurerepublic SET value=? WHERE domainid=? AND name=?",array($data[$k],$params['domainid'],$k));
            }
        }
    }
}

function infrastructurerepublic_AdminDomainsTabFields($params) {
    
    $fields = infrastructurerepublic_getModuleFields($params);
    $fieldsarray = array();
    
    foreach($fields as $k => $field){
        $fieldsarray[$field['label']] = $field['html'];
    }
    
    return $fieldsarray;
}
function infrastructurerepublic_AdminDomainsTabFieldsSave($params) {
    
    $data = array();
    foreach($_POST['modulefields'] as $k => $v){
        $data[$k] = $v;
    }
    infrastructurerepublic_saveModuleFields($params,$data);
}

function infrastructurerepublic_getCustomer($params){
    
    mysql_safequery("
			CREATE TABLE IF NOT EXISTS  `infrastructurerepubliccustomers` (
			`wwwid` INT( 11 ) NOT NULL ,
			`whmcsid` INT( 11 ) NOT NULL ,
			`pwd` VARCHAR( 15 ) NOT NULL
			) ENGINE = INNODB
    ");
	if(isset($params['userid'])){
		$res = mysql_safequery("SELECT * FROM infrastructurerepubliccustomers WHERE whmcsid=?",array($params['userid']));
		$row = mysql_fetch_assoc($res);
		return $row['wwwid'];
	}else if(isset($params['soldto'])){
		$res = mysql_safequery("SELECT * FROM infrastructurerepubliccustomers WHERE wwwid=?",array($params['soldto']));
		$row = mysql_fetch_assoc($res);
		return $row['wwwid'];
	}
}

function infrastructurerepublic_addCustomer($whmcsid,$wwwid,$randpwd){
    
    mysql_safequery("INSERT INTO infrastructurerepubliccustomers (wwwid,whmcsid,pwd) VALUES (?,?,?)",array($wwwid,$whmcsid,$randpwd));
}

function infrastructurerepublic_getConfigArray() 
{
    $configarray = array
    (   "FriendlyName"      => array( 
            "Type"          => "System", 
            "Value"         => "Infrastructure Republic",
        ),
        "server_username" => array
        (
            'FriendlyName'  =>  'Acting User ID',
            "Type"          =>  "text",
            "Size"          =>  "20",
            "Description"   =>  "Enter Acting User ID here",
        ),
        "public_key"   => array
        (
            'FriendlyName'  =>  'Public Key',
            "Type"          =>  "password",
            "Size"          =>  "20",
            "Description"   =>  "Enter your Public Key here", 
        ),
        "private_key"   => array
        (
            'FriendlyName'  =>  'Private Key',
            "Type"          =>  "password",
            "Size"          =>  "20",
            "Description"   =>  "Enter your Private Key here", 
        ),
        'server_host'       =>  array
        (
            'FriendlyName'  =>  'Server',
            'Type'          =>  'text',
            'Size'          =>  '20',
            "Description"   =>  "Provide your registrar url. Eg. pub-infrastructurerepublic.com", 
        ),
        'soldby'    => array(
            'FriendlyName'  =>  'Sold By',
            'Type'          =>  'text',
            'Size'          =>  '20',
            "Description"   =>  "Enter Seller User ID here", 
        ),
		'promo_details'    => array(
            'FriendlyName'  =>  'Promo Details',
            'Type'          =>  'textarea',
            "Description"   =>  "Mention TLD,TransactionType,Promo code,Term in separate lines: <br> Example: COM,Register,GREATOFFER,1<br>
NET,Renew,BETTEROFFER,2<br>
ORG,Transfer,AWESOMEOFFER,1<br>", 
        ),
    );

    return $configarray;

}

function infrastructurerepublic_getContacts($params,$customerid){
    
    $www = new infrastructurerepublic($params['server_username'], $params['public_key'], $params['private_key'], $params['server_host']);

    $contacts = array();
    $details = array();
    $types = array('admin','registrant','billing','tech');
    foreach($types as $type){
        if(isset($params[$type.'firstname'])){
			$prefix = $type;
				if(trim($params[$type.'firstname']) == '' || trim($params[$type.'email']) == '' || trim($params[$type.'address1']) == ''){
					$prefix='';
				}
            list($ext,) = explode('.',$params[$prefix.'fullphonenumber']);
            $details[$type] = array(
                    'metadata' => array(
                        'userID' => $customerid,
                    ),
                    "email"         => $params[$prefix.'email'],
                    "postalInfo"    => array(
                        "name"              => $params[$prefix.'firstname'].' '.$params[$prefix.'lastname'],
                        "organization"      => $params[$prefix.'companyname'],
                        "address" => array(
                            "street" => array(
                                $params[$prefix.'address1'],
                                '', 
                                '',
                            ),
                            "city"          => $params[$prefix.'city'],
                            "state"         => $params[$prefix.'fullstate'],
                            "countryCode"   => $params[$prefix.'country'],
                            "postalCode"    => $params[$prefix.'postcode']
                        )
                    ),
                    "voice" => array(
                        "number" => $params[$prefix.'fullphonenumber'],
                        "ext" => ltrim($ext,'+'),
                    ),
            );
        }
    }
    
    if(!isset($details['registrant'])){ $details['registrant'] = $details['admin']; }
    if(!isset($details['billing'])){ $details['billing'] = $details['admin']; }
    if(!isset($details['tech'])){ $details['tech'] = $details['admin']; }

    foreach($types as $type){
        
        $www->addContact($params['tld'],$details[$type]);
        if($www->getResultCode() != "1") {
            throw new Exception($www->getError());
        }
        $res = $www->getResponse();
        if(!$res['response']['contactID']) {
            throw new Exception('Cannot Create Contact');
        }

        $contacts[$type] = $res['response']['contactID'];
    }

    return $contacts;

}

function infrastructurerepublic_RegisterDomain($params) {
	try{
        $www = new infrastructurerepublic($params['server_username'], $params['public_key'], $params['private_key'], $params['server_host']);
        $wwwid = infrastructurerepublic_getCustomer($params);
        if(!$wwwid){
  
            $www->addCustomer($params, $randpwd = $www->pwdGen());
            $res = $www->getResponse();

            if($www->getResultCode() != "1") {
                return array("error" => $www->getError());
            }
            
            $wwwid = $res['response']['id'];
            infrastructurerepublic_addCustomer($params['userid'],$wwwid,$randpwd);
        }
		
        //$www->activateCustomer($wwwid);
        //$res = $www->getResponse();
        $params['soldto'] = $wwwid;

        //code to get PROMO Code "promocode"
		//$promotion = $www->getPromoStatus($params['domainid'], $params['domainname'], $params['regperiod'], $wwwid, 'registration');
		//end
		
		//if($promotion['promoApplicable'] && !$promotion['promoAvailable']){
		//	return array('error' => $promotion['promoMessage']);
		//}
        $fields = infrastructurerepublic_getModuleFields($params);
		if($fields['invoiceid']['value']){
			$invData = $www->getInvoiceData($fields['invoiceid']['value']);
			if($invData['response']['status'] == 'cancelled'){
				unset($fields['invoiceid']);
			}
		}
        if(!$fields['invoiceid']['value']){

            /*
             * check availability
             */
			if(strtolower(substr($params['domainname'], 0, 4)) == 'www.') {
				$params['domainname'] = substr($params['domainname'], 4);
			}
            $www->checkAvailability($params['domainname']);
            if($www->getResultCode() != "1") {
                return array("error" => $www->getError());
            }
            $res = $www->getResponse();
            if($res['response']['avail'] != "1") {
                return array('error' => 'Domain name is not available!');
            }

            /*
             * create invoice
             */
			$promoCode = infrastructurerepublic_GetPromotionCodesByTLD($params);
			$promArray = array();
			if(is_array($promoCode) && !empty($promoCode)){
				foreach($promoCode as $tld => $action){
					foreach($action as $a => $period){
						krsort($period);
						$promArray[$tld][$a] = $period;
					}
				}
				if(isset($promArray[$params['tld']]['register'])){
					foreach($promArray[$params['tld']]['register'] as $pr => $code){
						if($params['regperiod'] == $pr){
							$promotionCode = $code;
							break;
						}
						if($params['regperiod'] > $pr){
							$promotionCode = $code;
						}
					}
				}else{
					$promotionCode = '';
				}
			}
			//echo "promo :".$promotionCode;
            $nameservers = array();
            if($params['ns1']){ $nameservers[] = $params['ns1']; }
            if($params['ns2']){ $nameservers[] = $params['ns2']; }
            if($params['ns3']){ $nameservers[] = $params['ns3']; }
            if($params['ns4']){ $nameservers[] = $params['ns4']; }
            if($params['ns5']){ $nameservers[] = $params['ns5']; }

            $data = array();
            $data['soldby'] = $params['soldby'];
            $data['soldto'] = $params['soldto'];

            $data['regperiod'] = $params['regperiod'];
            $data['name'] = $params['domainname'];
            $data['nameservers'] = $nameservers;
            $data['contacts'] = infrastructurerepublic_getContacts($params,$params['soldto']);
			if($promotionCode != ''){
				$data['promoCode'] = $promotionCode;
			}
			
            $www->createInvoice($data);
            if($www->getResultCode() != "1") {
                return array("error" => $www->getError());
            }
            $res = $www->getResponse();
            $savedata = array();
            $savedata['invoiceid'] = $res['response']['id'];
            $savedata['orderid'] = $res['response']['orderID'];

            infrastructurerepublic_saveModuleFields($params, $savedata);
			if(isset($data['promoCode']) &&  $res['response']['promoApplyed'] != 1){
				return array("error" =>  $res['response']['promoErrorMessage']);
			}
            $invoiceid = $res['response']['id'];
        }
        else{
            $invoiceid = $fields['invoiceid']['value'];
			/*
             * update invoice
             */
			$promoCode = infrastructurerepublic_GetPromotionCodesByTLD($params);
			$promArray = array();
			if(is_array($promoCode) && !empty($promoCode)){
				foreach($promoCode as $tld => $action){
					foreach($action as $a => $period){
						krsort($period);
						$promArray[$tld][$a] = $period;
					}
				}
				if(isset($promArray[$params['tld']]['register'])){
					foreach($promArray[$params['tld']]['register'] as $pr => $code){
						if($params['regperiod'] == $pr){
							$promotionCode = $code;
							break;
						}
						if($params['regperiod'] > $pr){
							$promotionCode = $code;
						}
					}
				}else{
					$promotionCode = '';
				}
			}
			$nameservers = array();
            if($params['ns1']){ $nameservers[] = $params['ns1']; }
            if($params['ns2']){ $nameservers[] = $params['ns2']; }
            if($params['ns3']){ $nameservers[] = $params['ns3']; }
            if($params['ns4']){ $nameservers[] = $params['ns4']; }
            if($params['ns5']){ $nameservers[] = $params['ns5']; }

            $data = array();
            $data['soldby'] = $params['soldby'];
            $data['soldto'] = $params['soldto'];

            $data['regperiod'] = $params['regperiod'];
            $data['name'] = $params['domainname'];
            $data['nameservers'] = $nameservers;
            $data['contacts'] = infrastructurerepublic_getContacts($params,$params['soldto']);
			
            $www->createInvoice($data);
            if($www->getResultCode() != "1") {
                return array("error" => $www->getError());
            }
        }
        
        $www->chargeInvoice($invoiceid, $params['regperiod'], $params['soldto']);
        if($www->getResultCode() != "1") {
            return array("error" => $www->getError());
        }
        $res = $www->getResponse();
        $savedata = array();
        $savedata['domainid'] = $res['response']['id'];
        infrastructurerepublic_saveModuleFields($params, $savedata);

        return array("success" => true);
    
    }
    catch(Exception $e){
        return array('error' => 'Error Occured: '.$e->getMessage());
    }
}

function infrastructurerepublic_TransferDomain($params)
{
    try{
        
        $www = new infrastructurerepublic($params['server_username'], $params['public_key'], $params['private_key'], $params['server_host']);
        
        $wwwid = infrastructurerepublic_getCustomer($params);

        if(!$wwwid){
            $www->addCustomer($params , $randpwd = $www->pwdGen());
            $res = $www->getResponse();
            
            if($www->getResultCode() != "1") {
                return array("error" => $www->getError());
            }
            //$www->activateCustomer();
            $wwwid = $res['response']['id'];
            infrastructurerepublic_addCustomer($params['userid'],$wwwid,$randpwd);
            
        }
        
        //$www->activateCustomer($wwwid);
        $params['soldto'] = $wwwid;
		$res = $www->getResponse();

        $fields = infrastructurerepublic_getModuleFields($params);
		
		if($fields['invoiceid']['value']){
			$invData = $www->getInvoiceData($fields['invoiceid']['value']);
			if($invData['response']['status'] == 'cancelled'){
				unset($fields['invoiceid']);
			}
		}
        if(!$fields['invoiceid']['value']){
            /*
             * check availability
             */
			if(strtolower(substr($params['domainname'], 0, 4)) == 'www.') {
				$params['domainname'] = substr($params['domainname'], 4);
			}
            $www->checkAvailability($params['domainname']);
            if($www->getResultCode() != "1") {
                return array("error" => $www->getError());
            }
            $res = $www->getResponse();

            if($res['response']['avail'] != "0") {
                return array('error' => 'Domain name is available for Registration!');
            }

            /*
             * create invoice
             */
			$promoCode = infrastructurerepublic_GetPromotionCodesByTLD($params);
			$promArray = array();
			if(is_array($promoCode) && !empty($promoCode)){
				foreach($promoCode as $tld => $action){
					foreach($action as $a => $period){
						krsort($period);
						$promArray[$tld][$a] = $period;
					}
				}
				if(isset($promArray[$params['tld']]['transfer'])){
					foreach($promArray[$params['tld']]['transfer'] as $pr => $code){
						if($params['regperiod'] == $pr){
							$promotionCode = $code;
							break;
						}
						if($params['regperiod'] > $pr){
							$promotionCode = $code;
						}
					}
				}else{
					$promotionCode = '';
				}
			}
            $nameservers = array();
            if($params['ns1']){ $nameservers[] = $params['ns1']; }
            if($params['ns2']){ $nameservers[] = $params['ns2']; }
            if($params['ns3']){ $nameservers[] = $params['ns3']; }
            if($params['ns4']){ $nameservers[] = $params['ns4']; }
            if($params['ns5']){ $nameservers[] = $params['ns5']; }

            $data = array();
            $data['soldby'] = $params['soldby'];
            $data['soldto'] = $params['soldto'];
			$data['authcode'] = $params['eppcode'];
            $data['regperiod'] = $params['regperiod'];
            $data['name'] = $params['domainname'];			
			$data['nameservertype'] = 'specify';
            $data['nameservers'] = $nameservers;
            $data['contacts'] = infrastructurerepublic_getContacts($params,$params['soldto']);//?
			if($promotionCode != ''){
				$data['promoCode'] = $promotionCode;
			}
			
            $www->createInvoice($data,'transfer');
            if($www->getResultCode() != "1") {
                return array("error" => $www->getError());
            }
            $res = $www->getResponse();

			if(isset($data['promoCode']) &&  $res['response']['promoApplyed'] != 1){
				return array("error" =>  $res['response']['promoErrorMessage']);
			}

            $savedata = array();
            $savedata['invoiceid'] = $res['response']['id'];
            $savedata['orderid'] = $res['response']['orderID'];

            infrastructurerepublic_saveModuleFields($params, $savedata);

            $invoiceid = $res['response']['id'];
        }
        else{
            $invoiceid = $fields['invoiceid']['value'];
			/*
             * create invoice
             */
			$promoCode = infrastructurerepublic_GetPromotionCodesByTLD($params);
			$promArray = array();
			if(is_array($promoCode) && !empty($promoCode)){
				foreach($promoCode as $tld => $action){
					foreach($action as $a => $period){
						krsort($period);
						$promArray[$tld][$a] = $period;
					}
				}
				if(isset($promArray[$params['tld']]['transfer'])){
					foreach($promArray[$params['tld']]['transfer'] as $pr => $code){
						if($params['regperiod'] == $pr){
							$promotionCode = $code;
							break;
						}
						if($params['regperiod'] > $pr){
							$promotionCode = $code;
						}
					}
				}else{
					$promotionCode = '';
				}
			}
            $nameservers = array();
            if($params['ns1']){ $nameservers[] = $params['ns1']; }
            if($params['ns2']){ $nameservers[] = $params['ns2']; }
            if($params['ns3']){ $nameservers[] = $params['ns3']; }
            if($params['ns4']){ $nameservers[] = $params['ns4']; }
            if($params['ns5']){ $nameservers[] = $params['ns5']; }

            $data = array();
            $data['soldby'] = $params['soldby'];
            $data['soldto'] = $params['soldto'];
			$data['authcode'] = $params['eppcode'];
            $data['regperiod'] = $params['regperiod'];
            $data['name'] = $params['domainname'];			
			$data['nameservertype'] = 'specify';
            $data['nameservers'] = $nameservers;
            $data['contacts'] = infrastructurerepublic_getContacts($params,$params['soldto']);//?
			if($promotionCode != ''){
				$data['promoCode'] = $promotionCode;
			}
			
            $www->createInvoice($data,'transfer');
            if($www->getResultCode() != "1") {
                return array("error" => $www->getError());
            }
        }
        
        $www->chargeInvoice($invoiceid, $params['regperiod'], $params['soldto']);
        if($www->getResultCode() != "1") {
            return array("error" => $www->getError());
        }
        $res = $www->getResponse();
        $savedata = array();
        $savedata['domainid'] = $res['response']['id'];
        infrastructurerepublic_saveModuleFields($params, $savedata);

        return array("success" => true);
    
    }
    catch(Exception $e){
        return array('error' => 'Error Occured: '.$e->getMessage());
    }
}

function infrastructurerepublic_RenewDomain($params) {
    
    try{
        $www = new infrastructurerepublic($params['server_username'], $params['public_key'], $params['private_key'], $params['server_host']);
		$res = $www->getDomainInfo($params['domainname']);
		$params['soldto'] = $res['response']['metadata']['order']['soldTo'];
        
        /*
         * create invoice
         */		 
        $fields = infrastructurerepublic_getModuleFields($params);
		$promoCode = infrastructurerepublic_GetPromotionCodesByTLD($params);
		$promArray = array();
		if(is_array($promoCode) && !empty($promoCode)){
			foreach($promoCode as $tld => $action){
				foreach($action as $a => $period){
					krsort($period);
					$promArray[$tld][$a] = $period;
				}
			}
		if(isset($promArray[$params['tld']]['renew'])){
			foreach($promArray[$params['tld']]['renew'] as $pr => $code){
				if($params['regperiod'] == $pr){
					$promotionCode = $code;
					break;
				}
				if($params['regperiod'] > $pr){
					$promotionCode = $code;
				}
			}
		}else{
			$promotionCode = '';
		}
		}
		if(!isset($fields['orderid']['value'])){
			$fields['orderid']['value'] = $res['response']['metadata']['order']['id'];
		}
        $orderid = $fields['orderid']['value'];
		$data = array();
        $data['period'] = $params['regperiod'];
		if($promotionCode != ''){
			$data['promoCode'] = $promotionCode;
		}

        $www->orderRenew($orderid,$data);
        if($www->getResultCode() != "1") {
            return array("error" => $www->getError());
        }
        $res = $www->getResponse();

        $invoiceid = $res['response']['id'];
		if(isset($data['promoCode']) &&  $res['response']['promoApplyed'] != 1){
				return array("error" =>  $res['response']['promoErrorMessage']);
		}
        $www->chargeInvoice($invoiceid, $params['regperiod'], $params['soldto']);
        if($www->getResultCode() != "1") {
            return array("error" => $www->getError());
        }

        return array("success" => true);
    
    }
    catch(Exception $e){
        return array('error' => 'Error Occured: '.$e->getMessage());
    }
}

function infrastructurerepublic_GetContactDetails($params)
{   

    $www = new infrastructurerepublic($params['server_username'], $params['public_key'], $params['private_key'], $params['server_host']);
    
    try{
        $res = $www->getDomainInfo($params['domainname']);  

        $contacts = array();
        $contactids =  array();
        if($res['response']['registrant']){ $contactids['registrant'] = $res['response']['registrant']; }
        if($res['response']['contacts']['admin'][0]){ $contactids['admin'] = $res['response']['contacts']['admin'][0]; }
        if($res['response']['contacts']['billing'][0]){ $contactids['billing'] = $res['response']['contacts']['billing'][0]; }
        if($res['response']['contacts']['tech'][0]){ $contactids['tech'] = $res['response']['contacts']['tech'][0]; }

        foreach($contactids as $type => $id){

            $res = $www->getDomainContactDetails($params['tld'],$id);
            $details = $res['response'];

            $ctype = ucfirst($type);

            $contacts[$ctype]['Full Name']    = $details['postalInfo']['name'];
            $contacts[$ctype]['Company Name']      = $details['postalInfo']['organization'];
            $contacts[$ctype]['Email']        = $details['email'];
            $contacts[$ctype]['Address']      = $details['postalInfo']['address']['street'][0];
            $contacts[$ctype]['City']         = $details['postalInfo']['address']['city'];
            $contacts[$ctype]['State']        = $details['postalInfo']['address']['state'];
            $contacts[$ctype]['ZIP Code']  = $details['postalInfo']['address']['postalCode'];
            $contacts[$ctype]['Country'] = $details['postalInfo']['address']['countryCode'];
            $contacts[$ctype]['Phone Number'] = $details['voice']['number'];
        }

        return $contacts;
    }
    catch(Exception $e){
        return array('error' => 'Error Occured: '.$e->getMessage());
    }
}

function infrastructurerepublic_SaveContactDetails($params) 
{
    
    $www = new infrastructurerepublic($params['server_username'], $params['public_key'], $params['private_key'], $params['server_host']);
    
    try{
    
        $res = $www->getDomainInfo($params['domainname']);  

        $contacts = $params['contactdetails'];
        $contactids =  array();
        if($res['response']['registrant']){ $contactids['registrant'] = $res['response']['registrant']; }
        if($res['response']['contacts']['admin'][0]){ $contactids['admin'] = $res['response']['contacts']['admin'][0]; }
        if($res['response']['contacts']['billing'][0]){ $contactids['billing'] = $res['response']['contacts']['billing'][0]; }
        if($res['response']['contacts']['tech'][0]){ $contactids['tech'] = $res['response']['contacts']['tech'][0]; }
        
        foreach($contactids as $type => $id){

            $res = $www->getDomainContactDetails($params['tld'],$id);
            $details = array(
                'postalInfo'    => $res['response']['postalInfo'],
                'voice'         => $res['response']['voice'],
                'email'         => $res['response']['email']
            );
            
            $ctype = ucfirst($type);
            
            $details['postalInfo']['name'] = $contacts[$ctype]['Full Name'];
            $details['postalInfo']['organization'] = $contacts[$ctype]['Company Name'];
            $details['email'] = $contacts[$ctype]['Email'];
            $details['postalInfo']['address']['street'][0] = $contacts[$ctype]['Address'];
            $details['postalInfo']['address']['city'] = $contacts[$ctype]['City'];
            $details['postalInfo']['address']['state'] = $contacts[$ctype]['State'];
            $details['postalInfo']['address']['postalCode'] = $contacts[$ctype]['ZIP Code'];
            $details['postalInfo']['address']['countryCode'] = $contacts[$ctype]['Country'];
            $details['voice']['number'] = $contacts[$ctype]['Phone Number'];
            $details['contactID'] = $id;
            
            $www->editContact($params['tld'],$id,$details);
            if($www->getResultCode() != "1") {
                return array("error" => $www->getError());
            }
            $res = $www->getResponse();
            
        }
        
        return array("success" => true);
    }
    catch(Exception $e){
        return array('error' => 'Error Occured: '.$e->getMessage());
    }
}

function infrastructurerepublic_GetNameservers($params) {
  
    try{
        $www = new infrastructurerepublic($params['server_username'], $params['public_key'], $params['private_key'], $params['server_host']);
        $qwe = $www->getDomainInfo($params['domainname']);  
        if($www->getResultCode() != "1") {
            return array("error" => $www->getError());
        }
        
        for($i=0;$i<5;$i++){
            $values["ns".($i+1)] = $qwe['response']['nameservers'][($i)];
        }
		//save data
		$fields = infrastructurerepublic_getModuleFields($params);
		$savedata = array();
		if(isset($fields['domainid']) && $fields['domainid']['value']=='')
			$savedata['domainid'] = $qwe['response']['id'];
		if(isset($fields['orderid']) && $fields['orderid']['value']=='')
			$savedata['orderid'] = $qwe['response']['metadata']['order']['id'];
		$savedata['domainstatus'] = $qwe['response']['metadata']['order']['showStatus'];
		$savedata['authcode'] = $qwe['response']['authcode'];

		infrastructurerepublic_saveModuleFields($params, $savedata);
		/**
		 * Log any call to the server
		 */
		logModuleCall('infrastructurerepublic', __FUNCTION__, $params, $savedata);
		//end

		//end

        $expirydate = date("Y-m-d",strtotime($qwe['response']['exDate']));

        $values['lockenabled'] = (in_array('clientTransferProhibited', $qwe['response']['status']))?"locked":"unlocked";
        $values['lockstatus'] = (in_array('clientTransferProhibited', $qwe['response']['status']))?"locked":"unlocked";
        $values['active'] = $res['response']['status'][0] == "ok";
        $values['expired'] = date("Y-m-d") > $expirydate;
        $values['expirydate'] = $expirydate;
        return $values;
    }
    catch(Exception $e){
        return array('error' => 'Error Occured: '.$e->getMessage());
    }
}

function infrastructurerepublic_GetRegistrarLock($params) {
	//the code is  same as above server
    $values = infrastructurerepublic_GetNameservers($params);
	return $values['lockenabled'];
}

function infrastructurerepublic_ClientAreaCustomButtonArray() {
    $buttonarray = array(
	 "EPP Information" => "getEPP",
	);
	return $buttonarray;
}

function infrastructurerepublic_getEPP($params) {
    $fields = infrastructurerepublic_getModuleFields($params);
	$savedata = array();
	$savedata['domainid'] = $params['domainid'];
	$savedata['domainname'] = $params['domainname'];
	$savedata['domainstatus'] = $fields['domainstatus']['value'];
	$savedata['authcode'] = $fields['authcode']['value'];
	return array(
		'templatefile' => 'domain_details',
		'breadcrumb' => array( 'clientarea.php?action=domaindetails&domainid='.$domainid.'&modop=custom&a=getEPP' => 'EPP Information' ),
		'vars' => $savedata,
	);
}

function infrastructurerepublic_SaveNameservers($params)
{
    $www = new infrastructurerepublic($params['server_username'], $params['public_key'], $params['private_key'], $params['server_host']);
    for($i=0;$i<5;$i++){
        if($params["ns".($i+1)]){
            $ns['nameservers'][$i] = $params["ns".($i+1)];
        }
    }
    
	$existNameServerArray = array();

	$values = array();

	try{
		$existNameServerArray = $www->getDomainInfo($params['domainname']);  
		
		$remove = array_diff($existNameServerArray['response']['nameservers'], $ns['nameservers']);
		
		if (count($remove) > 0){
			$values['removeNameservers'] = array_values($remove);
		}

	}catch(Exception $e){
		$existNameServerArray = array();
	}
	
	$values['nameservers'] = $ns['nameservers'];
    $values['name'] = $params['domainname'];
    $values['nameservertype'] = 'specify';
    $www->setNameServers($values); 
    if($www->getResultCode() != "1") {
        return array("error" => $www->getError());
    }
    
    return array("success" => true);
}
function infrastructurerepublic_SaveRegistrarLock($params)
{
    $www = new infrastructurerepublic($params['server_username'], $params['public_key'], $params['private_key'], $params['server_host']);
	$lockStatus = $params['lockenabled'];
    $getCurrentData = infrastructurerepublic_GetRegistrarLock($params);
    if($getCurrentData != $lockStatus){
		$values = array();
		if ($lockStatus == 'locked')
            $values['status'] = array('clientTransferProhibited');
        else if ($lockStatus == 'unlocked')
            $values['removeStatus'] = array('clientTransferProhibited');
		
		$values['name'] = $params['domainname'];
		$www->setNameServers($values); 
		if($www->getResultCode() != "1") {
			return array("error" => $www->getError());
		}
	}
    return array("success" => true);
}

function infrastructurerepublic_GetDNS($params){

    try{
    
        $www = new infrastructurerepublic($params['server_username'], $params['public_key'], $params['private_key'], $params['server_host']);
        $res = $www->getDomainInfo($params['domainname']);  
        if($www->getResultCode() != "1") {
            return array("error" => $www->getError());
        }

        $records = array();
        foreach($res['response']['hosts'] as $r){
            $records[] = array(
                'recid'     => $r['id'],
                'hostname'  => $r['name'],
                'type'      => 'A',
                'address'   => $r['ip'][0],
            );
        }
        
        return $records;

    }
    catch(Exception $e){
        return array('error' => 'Error Occured: '.$e->getMessage());
    }
}

function infrastructurerepublic_SaveDNS($params){
    
    try{
    
        $www = new infrastructurerepublic($params['server_username'], $params['public_key'], $params['private_key'], $params['server_host']);

        $add = $edit = $remove = array();
        $temp_current = infrastructurerepublic_GetDNS($params);
        $current = array();
        foreach($temp_current as $tc){
            $current[$tc['recid']] = $tc;
        }

        foreach($params['dnsrecords'] as $r){
            if($r['recid']){
                if($r['hostname']){
                    if($r['address']!=$current[$r['recid']]['address']){
                        $edit[$r['hostname']][] = array(
                            'version' => $r['type'] == 'AAAA' ? 'v6' : 'v4',
                            'address' => $r['address'],
                        );
                    }
                }
                else{
                    $remove[$current[$r['recid']]['hostname']][] = array(
                        'version' => $r['type'] == 'AAAA' ? 'v6' : 'v4',
                        'address' => $r['address'],
                    );
                }
                unset($current[$r['recid']]);
            }
            else{
                if($r['hostname']){
                    $add[$r['hostname']][] = array(
                        'version' => $r['type'] == 'AAAA' ? 'v6' : 'v4',
                        'address' => $r['address'],
                    );
                }
            }
        }

        foreach($add as $name => $addresses){
            $www->addChildNameServer($params['tld'],$name,$addresses,$params['soldto']);
            if($www->getResultCode() != "1") {
                return array("error" => 'Error Occured: '.$www->getError());
            }
        }
        $modify_addresses = array();
        foreach($edit as $name => $addresses){
            if(!$modify_addresses[$name]['edit']){
                $modify_addresses[$name]['edit'] = array();
            }
            $modify_addresses[$name]['edit'] = array_merge($modify_addresses[$name]['edit'],$addresses);
        }
        foreach($remove as $name => $addresses){
            if(!$modify_addresses[$name]['remove']){
                $modify_addresses[$name]['remove'] = array();
            }
            $modify_addresses[$name]['remove'] = array_merge($modify_addresses[$name]['remove'],$addresses);
        }
        
        foreach($modify_addresses as $hostname => $addresses){
            if(!is_array($addresses['edit'])){
                $addresses['edit'] = array();
            }
            if(!is_array($addresses['remove'])){
                $addresses['remove'] = array();
            }
            $www->editChildNameServer($params['tld'],$hostname,$addresses['edit'],$addresses['remove'],$params['soldto']);
            if($www->getResultCode() != "1") {
                return array("error" => 'Error Occured: '.$www->getError());
            }
        }
        return array("success" => true);
    
    }
    catch(Exception $e){
        return array('error' => 'Error Occured: '.$e->getMessage());
    }

}

function infrastructurerepublic_Sync($params) {
    
    try{
        
        $www = new infrastructurerepublic($params['server_username'], $params['public_key'], $params['private_key'], $params['server_host']);
        $values = array();
        
        $res = $www->getDomainInfo($params['domain']);  
		
		logModuleCall('infrastructurerepublic', __FUNCTION__, $params, $res);

        if($www->getResultCode() != "1") {
            return array("error" => $www->getError());
        }

        $expirydate = date("Y-m-d",strtotime($res['response']['exDate']));

        $values['active'] = $res['response']['status'][0] == "ok";
        $values['expired'] = date("Y-m-d") > $expirydate;
        $values['expirydate'] = $expirydate;
        
        return $values;

    }
    catch(Exception $e){
        return array('error' => 'Error Occured: '.$e->getMessage());
    }
}

function infrastructurerepublic_TransferSync($params) {
    
    try{
        
        $www = new infrastructurerepublic($params['server_username'], $params['public_key'], $params['private_key'], $params['server_host']);
        $values = array();
        
        $res = $www->getDomainInfo($params['domain']);  
		
		logModuleCall('infrastructurerepublic', __FUNCTION__, $params, $res);

        if($www->getResultCode() != "1") {
            return array("error" => $www->getError());
        }

        if($res['response']['status'][0] == "ok" && $res['response']['transfer_in_status']){
            $values['completed'] = true;
            $values['expirydate'] = date("Y-m-d",strtotime($res['response']['exDate']));
        }
        else{
            $values['failed'] = true;
            $values['reason'] = "Transfer Failed";
        }
        
        return $values;
    }
    catch(Exception $e){
        return array('error' => 'Error Occured: '.$e->getMessage());
    }
}

function infrastructurerepublic_GetPromotionCodesByTLD($params) {
    try{
        $promotion_code = $params['promo_details'];
		$promotion_code = explode(PHP_EOL, $promotion_code);
		$respArray = array();
        if(is_array($promotion_code)){
			foreach($promotion_code as $csv){
				//check if the line is empty
				if(trim($csv) == '')
					continue;

				$tldCode = explode(',', $csv);

				//check if csv has atleast 3 value
				if(!isset($tldCode[0]))
					continue;
				if(!isset($tldCode[1]))
					continue;
				if(!isset($tldCode[2]))
					continue;
				if(!isset($tldCode[3]))
					continue;

				//check if the 
				//echo $params['regperiod'].'---'. $tldCode[3];die;
				if(intval($params['regperiod']) >= intval($tldCode[3])){
				$tld= ltrim(trim(strtolower($tldCode[0])),'.');
				$action=trim(strtolower($tldCode[1]));
				$period=trim(strtolower($tldCode[3]));
				if(!isset($tld)){
					$respArray[$tld] = array();
				}
				$respArray[$tld][$action][$period] = trim($tldCode[2]);
				}
			}
		}
        
        return $respArray;
    }
    catch(Exception $e){
        return array();
    }
}
